//+------------------------------------------------------------------+
//|                                                   PerAlertItzkov |
//|                                                 Peter Storozenko |
//|                                               pitpiter@gmail.com |
//+------------------------------------------------------------------+

#property copyright "Peter Storozenko"
#property link      "pitpiter@gmail.com"

#property indicator_chart_window
#property indicator_buffers 2

//--- indicator parameters

extern double ArrowDistance=30;
extern color BuyColor=Green;
extern color SellColor=Red;
extern bool PopupAlert=true;
extern bool SoundAlert=true;
extern string UpSound="tick";
extern string DownSound="alert";
extern string __="Indicators setting";
extern string NameIndicator1="uuperArrowIndicatorp";
extern int FasterMAInd1=5;
extern int SlowMAInd1=200;
extern int RSIPeriodInd1=12;
extern int MagicFilterPeriodInd1=14;
extern int BBPeriodInd1=20;
extern int BBShiftInd1=0;
extern double BBDeviationInd1=1.6;
extern int BulsPowerPerInd1=50;
extern int BearsPowerPerInd1=50;
extern string NameIndicator2="vladimir__itzkov";
extern int NumberOffBarsInd2=1000;
extern int RSIPeriodInd2=12;
extern int CCIPeriodInd2=21;
extern int STKPeriodInd2=5;
extern int STDPeriodInd2=3;
extern int STSlowingInd2=2;
extern int STOBoughtInd2=60;
extern int STOVSoldInd2=40;
extern int ADXPeriodInd2=34;
extern int BulsPeriodInd2=50;
extern int BearsPeriodInd2=50;
extern int BBPeriodInd2=20;
extern int BBShiftInd2=0;
extern double BBDeviationInd2=1.6;

//--- buffers

double ExtUpperBuffer[];
double ExtLowerBuffer[];

bool START;
int count;
datetime data;
int init() 
{
   IndicatorBuffers(2);
   IndicatorDigits(Digits);
//--- upper arrow
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,2,BuyColor);
   SetIndexBuffer(0,ExtUpperBuffer);
//   SetIndexShift(0,InpBandsShift);
   SetIndexLabel(0,"Upper Arrow");
//--- lower arrow
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,2,SellColor);
   SetIndexBuffer(1,ExtLowerBuffer);
//   SetIndexShift(1,InpBandsShift);
   SetIndexLabel(1,"Lower Arrow");

   SetIndexArrow(0, 233);
   SetIndexArrow(1, 234);
   START=true;
   count=0;
   data=0;
  return(0);
}
			    	     	   

int deinit() 
{
   return (0);
}
			   		     		  

int start() 
{
   int i;
   int    limit, signal;
   int    counted_bars=IndicatorCounted();
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   if(START)
   {
    count++;
    if(count>3)START=false;
    limit=Bars-1; 
    for(i=1; i<=limit; i++)
    {
        signal=Signal(i);
        if(signal==1) 
        {
          ExtUpperBuffer[i]=Low[i]-ArrowDistance*Point;
        }  
        if(signal==2) 
        {
          ExtLowerBuffer[i]=High[i]+ArrowDistance*Point;
        }     
    }
   }
   signal=Signal(1);
   if(signal>0 && data!=Time[0])
   {
     
     if(signal==1) 
     {
       ExtUpperBuffer[1]=Low[1]-ArrowDistance*Point;
       DoAlert(1);
     }
     if(signal==2) 
     {
        ExtLowerBuffer[1]=High[1]+ArrowDistance*Point;
        DoAlert(2);
     }
     data=Time[0];
   }  
   return(0);   
}
void DoAlert(int a)
{
  string text=Symbol()+" "+Frame(Period())+" "+TimeToStr(Time[0],TIME_DATE|TIME_MINUTES|TIME_SECONDS)+"  PerAlertItzkov";
  string sound;
  switch(a)
  {
    case 1 :
    {
      text=text+" BUY Signal";
      sound=UpSound;
      break;
    }
    case 2 :
    {
      text=text+" SELL Signal";
      sound=DownSound;
      break;    
    }
  }
  if(PopupAlert)Alert(text);
  if(SoundAlert)PlaySound(sound);
  return;
}
string Frame(int a)
{
    string per;
            switch(a)
            {
              case 1 : per="M1";break;
              case 5 : per="M5";break;
              case 15: per="M15";break;
              case 30: per="M30";break;
              case 60: per="H1";break;
              case 240:per="H4";break;
              case 1440:per="D1";break;
              case 10080:per="W1";break;
              case 43200:per="MN";break;
            }
        return(per); 
}
int Signal(int n)
{
  int a=0;
  double bbalertUp=NormalizeDouble(iCustom(Symbol(),0,NameIndicator1,FasterMAInd1,SlowMAInd1,RSIPeriodInd1,MagicFilterPeriodInd1,BBPeriodInd1,
                                           BBShiftInd1,BBDeviationInd1,BulsPowerPerInd1,BearsPowerPerInd1,false,0,n),Digits);
  double bbalertDn=NormalizeDouble(iCustom(Symbol(),0,NameIndicator1,FasterMAInd1,SlowMAInd1,RSIPeriodInd1,MagicFilterPeriodInd1,BBPeriodInd1,
                                           BBShiftInd1,BBDeviationInd1,BulsPowerPerInd1,BearsPowerPerInd1,false,1,n),Digits);
  double lizUp=NormalizeDouble(iCustom(Symbol(),0,NameIndicator2,NumberOffBarsInd2,RSIPeriodInd2,CCIPeriodInd2,STKPeriodInd2,STDPeriodInd2,
  STSlowingInd2,STOBoughtInd2,STOVSoldInd2,ADXPeriodInd2,BulsPeriodInd2,BearsPeriodInd2,BBPeriodInd2,BBShiftInd2,BBDeviationInd2,false,0,n),Digits);
  double lizDn=NormalizeDouble(iCustom(Symbol(),0,NameIndicator2,NumberOffBarsInd2,RSIPeriodInd2,CCIPeriodInd2,STKPeriodInd2,STDPeriodInd2,
  STSlowingInd2,STOBoughtInd2,STOVSoldInd2,ADXPeriodInd2,BulsPeriodInd2,BearsPeriodInd2,BBPeriodInd2,BBShiftInd2,BBDeviationInd2,false,1,n),Digits);  
  if(bbalertDn!=EMPTY_VALUE&&bbalertUp!=0&&lizDn!=0&&lizDn!=EMPTY_VALUE)
  { 
    a=2;
  }
  if(bbalertUp!=EMPTY_VALUE&&bbalertDn!=0&&lizUp!=0&&lizUp!=EMPTY_VALUE)
  {
    a=1;
  }
  return(a);
}
